#ifndef _OcclusionCullingTerrainSceneManager_H__
#define _OcclusionCullingTerrainSceneManager_H__

#include <OgreSceneNode.h>
#include <OgreOctreeSceneManager.h>
#include <OgreTerrainSceneManager.h>
#include <OgreOctreeSceneQuery.h>
#include <OgreOctreeNode.h>
#include <OgreOctreeCamera.h>

#include "OgrePrerequisites.h"
#include "OgreOcclusionCullingOctreeSceneTraverser.h"

using namespace std;

namespace Ogre {
	/**
		Class which implements a scene mangager which uses occlusion queries for culling occluded objects
	*/
	class OcclusionCullingTerrainSceneManager: public TerrainSceneManager
	{
	public:
		OcclusionCullingTerrainSceneManager();
		~OcclusionCullingTerrainSceneManager();
	
		void _renderVisibleObjects(void);
		void _findVisibleObjects(Camera* cam, bool onlyShadowCasters);
		void _updateSceneGraph(Camera* cam);

		/** Sets the given option for the SceneManager
			       @remarks
			Options are:
			"Algorithm", int *;			
		*/
		
		virtual bool setOption( const String &, const void * );
		/** Gets the given option for the Scene Manager.
	        @remarks
		    See setOption
		*/
		virtual bool getOption( const String &, void * );

		bool getOptionValues( const String & key, StringVector &refValueList );
		bool getOptionKeys( StringVector &refKeys );

	protected:

		OcclusionCullingOctreeSceneTraverser *mOcclusionCullingOctreeSceneTraverser;
	};

}
#endif // OcclusionCullingTerrainSceneManager_H